<?

class dynCalendarSpan {
  ////////////////////////////////////////////////////////////////////////////
  function dynCalendarSpan($id, $group, $start, $end, $period, $comments, $additionalFields) {    
    $this->id = $id;
    $this->start = $start;
    $this->end = $end;
    $this->period = $period;
    $this->group = $group;
    $this->comments = $comments;
    $this->additionalFields = $additionalFields;
  }

  ////////////////////////////////////////////////////////////////////////////
  function loadFromString($str) {
    $elts = split(',', $str);
    $this->id = (int)$elts[0];
    $this->start->loadFromString($elts[1]);
    $this->end->loadFromString($elts[2]);
    $this->period = (int)$elts[3];
    $this->group = (int)$elts[4];
    $this->comments = stripslashes($elts[5]);
  }
  
  ////////////////////////////////////////////////////////////////////////////
  function getMySQLInsert($table) {
    $res = "INSERT INTO $table (id, start, end, period, group, comments";
    foreach ($this->additionalFields as $key => $value) {
      $res .= ", $key";
    }
    
    $res .= ') VALUES (';
    
    $res .= 'NULL, ';
    $res .= mktime(0, 0, 0, $this->start->month + 1, $this->start->day, $this->start->year) . ', ';
    $res .= mktime(0, 0, 0, $this->end->month + 1, $this->end->day, $this->end->year) . ', ';
    $res .= $this->period . ', ';
    $res .= $this->group . ", '";
    $res .= mysql_escape_string($this->comments) . "'";
    foreach ($this->additionalFields as $value) {
      $res .= ", '" . mysql_escape_string($value) . "'";
    }

    $res .= ')';

    return $res;
  }

  ////////////////////////////////////////////////////////////////////////////
  function getMySQLUpdate($table) {
    $res = "UPDATE $table SET ";
    
    $res .= 'start = ' . mktime(0, 0, 0, $this->start->month + 1, $this->start->day, $this->start->year) . ', ';
    $res .= 'end = ' . mktime(0, 0, 0, $this->end->month + 1, $this->end->day, $this->end->year) . ', ';
    $res .= 'period = ' . $this->period . ', ';
    $res .= 'group = ' . $this->group . ", ";
    $res .= "comments = '" . mysql_escape_string($this->comments) . "'";
    
    foreach ($this->additionalFields as $key => $value) {
      $res .= ", $key = '" . mysql_escape_string($value) . "'";
    }

    $res .= " WHERE id = $this->id";

    return $res;
  }

  ////////////////////////////////////////////////////////////////////////////
  function getMySQLDelete($table) {
    return "DELETE FROM $table WHERE id = $this->id";
  }
  
}

?>
